# Copyright (C) 2005 by Aaron Bentley

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
import errno
import os
import shutil
from bzrlib.branch import Branch

def clean_tree(unknowns=True, ignored=False):
    def deletables(tree):
        for subp in tree.extras():
            if tree.is_ignored(subp):
                if not ignored:
                    continue
            else:
                if not unknowns:
                    continue
            yield tree.abspath(subp), subp
    br = Branch.open_containing('.')
    tree = br.working_tree()
    printed_once = False
    for path, subp in deletables(tree):
        if not printed_once:
            print "deleting paths:"
            printed_once = True
        print ' ', subp
        if os.path.isdir(path):
            shutil.rmtree(path)
        else:
            os.unlink(path)
